VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ChannelList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Fool's Internal Channel list
'Stores all the users in channel in arrays, for use when the GUI is disabled
'Also provides functions for wildcarding the channel(ban *, etc..)

Private Username() As String
Private UserPing() As Long
Private UserClan() As String
Private UserStatString() As String
Private UserProd() As String
Private UserFlags() As Long
Private Banned() As String

Private Sub Class_Initialize()
ReDim Username(0) As String
ReDim UserPing(0) As Long
ReDim UserClan(0) As String
ReDim UserStatString(0) As String
ReDim UserProd(0) As String
ReDim UserFlags(0) As Long
ReDim Banned(0) As String
End Sub


Public Function add(user As String, Ping As Long, Clan As String, Product As String, Flags As Long, statstring As String) As String
'this returns the statsstring of the user if it already exists, for use during flags change
'search through
On Error Resume Next
Dim x As Integer

For x = 1 To UBound(Username)
    If LCase(Username(x)) = LCase(user) Then
        'update the user
        If Ping <> 0 Then UserPing(x) = Ping
        If Clan <> vbNullString Then UserClan(x) = Clan
        If Product <> vbNullString Then UserProd(x) = Product
        If Flags <> 0 Then UserFlags(x) = Flags
        If statstring <> vbNullString Then UserStatString(x) = statstring
        add = UserStatString(x)
        Exit Function
    End If
Next x

x = UBound(Username) + 1
ReDim Preserve Username(x) As String
ReDim Preserve UserPing(x) As Long
ReDim Preserve UserClan(x) As String
ReDim Preserve UserStatString(x) As String
ReDim Preserve UserProd(x) As String
ReDim Preserve UserFlags(x) As Long
Username(x) = user
UserPing(x) = Ping
UserClan(x) = Clan
UserProd(x) = Product
UserFlags(x) = Flags
UserStatString(x) = statstring
add = UserStatString(x)

'check loadmode upper bound
If (Not loadMode) And UBound(Username) >= loadUpperBound And loadUpperBound > 3 And loadLowerBound > 3 Then
    If loadUpperBound <= loadLowerBound Then Exit Function
    loadMode = True
    frmMain.AddChat "[Bot] Loadmode Enabled(" & loadUpperBound & " users in channel)", vbYellow
End If
End Function

Public Sub remove(user As String)
On Error Resume Next
Dim y As Integer, x As Integer
lastLeaveUser = LCase(user)

For x = 1 To UBound(Username)
    If LCase(Username(x)) = LCase(user) Then
        'remove user by bumping everything else up
        Username(x) = vbNullString 'remove their ban from array
    For y = x To UBound(Username) - 1
        Username(y) = Username(y + 1) 'bump everything in array
        UserPing(y) = UserPing(y + 1) 'bump everything in array
        UserProd(y) = UserProd(y + 1) 'bump everything in array
        UserStatString(y) = UserStatString(y + 1) 'bump everything in array
        UserFlags(y) = UserFlags(y + 1) 'bump everything in array
        UserClan(y) = UserClan(y + 1) 'bump everything in array
    Next y
    x = UBound(Username) - 1
    ReDim Preserve Username(x) As String
    ReDim Preserve UserPing(x) As Long
    ReDim Preserve UserClan(x) As String
    ReDim Preserve UserStatString(x) As String
    ReDim Preserve UserProd(x) As String
    ReDim Preserve UserFlags(x) As Long
    Exit For
    End If
Next x


If loadLowerBound < 3 Then loadLowerBound = 18 ' raise it by default
If loadMode And UBound(Username) <= loadLowerBound Then
    If loadUpperBound <= loadLowerBound Then Exit Sub
    loadMode = False
    frmMain.AddChat "[Bot] Loadmode Disable(" & loadLowerBound & " users in channel)", vbYellow
End If
End Sub

Public Sub GUIUpdate()
On Error Resume Next
frmMain.channelUsers.ListItems.Clear
cChannelCount = 0
Dim x As Integer
'frmMain.AddChat UBound(username) & "Users in channel"
For x = 1 To UBound(Username)
    frmMain.ChannelAdd Username(x), UserFlags(x), UserProd(x), UserStatString(x), UserPing(x), vbNullString, vbNullString, UserClan(x)
Next x
End Sub

Public Sub ClearArray()
x = 0
ReDim Preserve Username(x) As String
ReDim Preserve UserPing(x) As Long
ReDim Preserve UserClan(x) As String
ReDim Preserve UserStatString(x) As String
ReDim Preserve UserProd(x) As String
ReDim Preserve UserFlags(x) As Long
End Sub

Public Function WildCardChannel(ByVal wc As String, Optional AllowOps As Boolean = True) As String()
Dim outar() As String
ReDim outar(0) As String
Dim lb As Integer, ub As String 'upper and lower bounds of section of array to search
lb = 1
ub = UBound(Username)
If Left$(wc, 1) = "%" Then 'parse out the %#-#
    Dim s() As String
    wc = Replace(wc, "%", vbNullString)
    s = Split(wc, "-", 2) 'split it up by the -, if it exists
    lb = CInt(s(0))
    If UBound(s) >= 1 Then ub = CInt(s(1))
    If ub > UBound(Username) Then ub = UBound(Username) 'check for overrun
    wc = "*"
End If
wc = LCase(wc)
Call PrepareCheck(wc)
Dim x As Integer
For x = lb To ub
If WildCardNoCheck(wc, LCase(Username(x))) Then
    If AllowOps Or (Not UserFlags(x) And 2) Then 'as long as they arn't channel operator
        c = UBound(outar)
        ReDim Preserve outar(c + 1) As String
        outar(c + 1) = Username(x)
    End If
End If
Next x
WildCardChannel = outar
'For x = 1 To UBound(outar)
'frmMain.AddChat (outar(x))
'Next x
End Function

Public Function SquelchWildCard(wc As String) As String()
Dim outar() As String
ReDim outar(0) As String
PrepareCheck (wc)
wc = LCase(wc)
Dim x As Integer
For x = 1 To UBound(Username)
If WildCardNoCheck(wc, LCase(Username(x))) Then
    If UserFlags(x) And 32 Then 'dont squelch if already squelched
    ElseIf Username(x) <> cUsername Then
    c = UBound(outar)
    ReDim Preserve outar(c + 1) As String
    outar(c + 1) = Username(x)
    End If
End If
Next x
SquelchWildCard = outar
For x = 1 To UBound(outar)
frmMain.AddChat (outar(x))
Next x
End Function

Public Function UnSquelchWildCard(wc As String) As String()
Dim outar() As String
ReDim outar(0) As String
PrepareCheck (wc)
wc = LCase(wc)
Dim x As Integer
For x = 1 To UBound(Username)
If WildCardNoCheck(wc, LCase(Username(x))) Then
    If UserFlags(x) And 32 Then 'find all squelched users
    c = UBound(outar)
    ReDim Preserve outar(c + 1) As String
    outar(c + 1) = Username(x)
    End If
End If
Next x
UnSquelchWildCard = outar
For x = 1 To UBound(outar)
frmMain.AddChat (outar(x))
Next x
End Function

Public Sub addBanned(ByVal user As String)
'frmMain.AddChat "AddBanned:" & user
If UBound(Banned) > 300 Then 'banned list is fucking huge, we need to reset it
    ReDim Preserve Banned(100) As String
End If
Dim tmpB As String, rUser As String
user = LCase(user)
tmpB = lastLeaveUser
If InStr(1, tmpB, "@") > 0 Then tmpB = Mid$(tmpB, 1, InStr(1, tmpB, "@") - 1) 'strip realms
If InStr(1, user, "@") > 0 Then user = Mid$(user, 1, InStr(1, user, "@") - 1) 'strip realms
Dim x As Integer
If LCase(tmpB) = user Then 'they match
    user = LCase(lastLeaveUser)
Else
    'find em in channel list
    For x = 1 To UBound(Username)
        tmpB = Username(x)
        If InStr(1, tmpB, "@") > 0 Then tmpB = Mid$(tmpB, 1, InStr(1, tmpB, "@") - 1) 'strip realms
        If LCase(tmpB) = user Then 'found match
            user = LCase(Username(x))
            Exit For
        End If
    Next x
End If

Dim fE As Integer 'first empty
fE = -1
For x = 1 To UBound(Banned)
    If Banned(x) = user Then Exit Sub   'already banned
    If Banned(x) = vbNullString And fE > 0 Then
        fE = x
    End If
Next x

If fE = -1 Then
    ReDim Preserve Banned(UBound(Banned) + 1)
    x = UBound(Banned)
End If
Banned(x) = user
'frmMain.AddChat "ActualBanned:" & user

End Sub

Public Sub remBanned(ByVal user As String)
On Error Resume Next
If InStr(1, user, "@") > 0 Then user = Mid$(user, 1, InStr(1, user, "@") - 1) 'strip realms
user = LCase(user)
For x = 1 To UBound(Banned)
    Dim bTemp As String
    bTemp = Banned(x)
    If InStr(1, bTemp, "@") > 0 Then bTemp = Mid$(bTemp, 1, InStr(1, bTemp, "@") - 1) 'strip realms
    If bTemp = user Then
        Banned(x) = vbNullString
    End If
Next x
End Sub

Public Function isBanned(ByVal user As String) As Boolean
On Error Resume Next
user = LCase(user)
For x = 1 To UBound(Banned)
    Dim bTemp As String
    If Banned(x) = user Then
        isBanned = True
        Exit Function
    End If
Next x
isBanned = False
End Function

Public Function WCUnban(wc As String) As String()
On Error Resume Next
Dim outar() As String, c As Integer
ReDim outar(0) As String
wc = LCase(wc)
PrepareCheck (wc)
Dim x As Integer
For x = 1 To UBound(Banned)
If WildCardNoCheck(wc, Banned(x)) And Banned(x) <> vbNullString Then
    c = UBound(outar)
    ReDim Preserve outar(c + 1) As String
    outar(c + 1) = Banned(x)
End If
Next x
WCUnban = outar
For x = 1 To UBound(outar)
'frmMain.AddChat (outar(x))
remBanned outar(x)
Next x
End Function
Function GetChannelList() As String()
On Error Resume Next
Dim Ret() As String
Ret = Username
Dim x As Integer
For x = LBound(Username) To UBound(Username)
    If UserFlags(x) And 2 Then 'they have ops
        Ret(x) = vbNullString
    End If
Next x
GetChannelList = Ret
End Function

Function GetBannedList()
On Error Resume Next
Dim dtalk As String, linecount As Integer, infront As String, inback As String
Dim userCount As Integer
userCount = 0
dtalk = "Banned: "
    
    For x = 1 To UBound(Banned)
        
       If Banned(x) <> vbNullString Then
       linecount = linecount + 1
       userCount = userCount + 1
        dtalk = dtalk & Banned(x)
        If x <> UBound(BotUser) Then dtalk = dtalk & ", "
        If linecount >= 5 Then
            dtalk = dtalk & vbCrLf & "Banned: " 'add a line every 6 users
            linecount = 0
        End If
    End If
    Next x
    dtalk = dtalk & "(" & userCount & " users)"
    GetBannedList = dtalk
    
End Function

Public Sub ClearBanList()
ReDim Banned(0) As String
End Sub

Public Function oneOps() As Boolean
oneOps = False
Dim x As Integer
For x = LBound(UserFlags) To UBound(UserFlags)
    If UserFlags(x) And 2 Then 'has ops then
        If oneOps = True Then
            oneOps = False
            Exit Function
        End If
        oneOps = True
    End If
Next x
End Function

Public Sub runBanCheck(mode As Byte)
For x = LBound(Username) To UBound(Username)
    Select Case mode
        Case 0
            doBotBan Username(x), UserPing(x), UserFlags(x)
        Case 1 'tagban/shitlist check
            shitJoin Username(x)
        Case 2 'lockdown/loadmode
            If getAccess(Username(x)) < LockDown Then
                If Not isSafeListed(Username(x)) Then AddQ "/ban " & Username(x) & " Lockdown", 3
            End If
        Case 3
        
    End Select
Next x

End Sub
